import { Part } from '@/Nest/Core/Part';
import { Path } from '@/Nest/Core/Path';
import { Point } from '@/Nest/Common/Point';

export class BlockView {
    ctx: CanvasRenderingContext2D
    constructor(canvas: HTMLCanvasElement) {
        this.ctx = canvas.getContext('2d');
    }
    update(board: Path, list: Part[]) {
        this.ctx.scale(0.5, 0.5);

        // this.ctx.rect(0,0,1220,2440);
        // this.ctx.stroke();
        this.drawPath(board);

        for (const part of list) {
            // console.log('parts',part);
            this.drawPath(part.RotatedStates[part.StateIndex].Contour,{x:part.PlacePosition.x/10000,y:part.PlacePosition.y/10000});

        }
    }

    private drawPath(path: Path, place: Point = { x: 0, y: 0 }) {
        
        this.ctx.beginPath();
        this.ctx.moveTo(path.Points[0].x+place.x, path.Points[0].y+place.y);
        for (const point of path.Points) {
            this.ctx.lineTo(point.x+place.x, point.y+place.y)
        }
        this.ctx.closePath();
        this.ctx.stroke();
    }


}